package net.minecraft.client;

import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Graphics;
import java.io.File;

import net.minecraft.src.AxisAlignedBB;
import net.minecraft.src.Block;
import net.minecraft.src.EffectRenderer;
import net.minecraft.src.EntityPlayer;
import net.minecraft.src.EntityPlayerSP;
import net.minecraft.src.EntityRenderer;
import net.minecraft.src.EnumOS2;
import net.minecraft.src.FontRenderer;
import net.minecraft.src.GLAllocation;
import net.minecraft.src.GameSettings;
import net.minecraft.src.GameWindowListener;
import net.minecraft.src.GuiChat;
import net.minecraft.src.GuiConflictWarning;
import net.minecraft.src.GuiConnecting;
import net.minecraft.src.GuiGameOver;
import net.minecraft.src.GuiIngame;
import net.minecraft.src.GuiIngameMenu;
import net.minecraft.src.GuiInventory;
import net.minecraft.src.GuiMainMenu;
import net.minecraft.src.GuiScreen;
import net.minecraft.src.GuiUnused;
import net.minecraft.src.ItemRenderer;
import net.minecraft.src.ItemStack;
import net.minecraft.src.LoadingScreenRenderer;
import net.minecraft.src.MathHelper;
import net.minecraft.src.MinecraftError;
import net.minecraft.src.MinecraftException;
import net.minecraft.src.MinecraftImpl;
import net.minecraft.src.ModelBiped;
import net.minecraft.src.MouseHelper;
import net.minecraft.src.MovementInputFromOptions;
import net.minecraft.src.MovingObjectPosition;
import net.minecraft.src.OpenGlCapsChecker;
import net.minecraft.src.PlayerController;
import net.minecraft.src.PlayerControllerTest;
import net.minecraft.src.RenderEngine;
import net.minecraft.src.RenderGlobal;
import net.minecraft.src.RenderManager;
import net.minecraft.src.ScaledResolution;
import net.minecraft.src.ScreenShotHelper;
import net.minecraft.src.Session;
import net.minecraft.src.SoundManager;
import net.minecraft.src.Teleporter;
import net.minecraft.src.Tessellator;
import net.minecraft.src.TextureCompassFX;
import net.minecraft.src.TextureFlamesFX;
import net.minecraft.src.TextureLavaFX;
import net.minecraft.src.TextureLavaFlowFX;
import net.minecraft.src.TexturePackList;
import net.minecraft.src.TexturePortalFX;
import net.minecraft.src.TextureWatchFX;
import net.minecraft.src.TextureWaterFX;
import net.minecraft.src.TexureWaterFlowFX;
import net.minecraft.src.ThreadDownloadResources;
import net.minecraft.src.ThreadSleepForever;
import net.minecraft.src.Timer;
import net.minecraft.src.UnexpectedThrowable;
import net.minecraft.src.Vec3D;
import net.minecraft.src.World;
import net.minecraft.src.WorldProvider;
import net.minecraft.src.WorldProviderHell;
import net.minecraft.src.WorldRenderer;

import org.lwjgl.LWJGLException;
import org.lwjgl.input.Controllers;
import org.lwjgl.input.Keyboard;
import org.lwjgl.input.Mouse;
import org.lwjgl.opengl.Display;
import org.lwjgl.opengl.DisplayMode;
import org.lwjgl.opengl.GL11;
import org.lwjgl.util.glu.GLU;

public abstract class Minecraft implements Runnable {
	public PlayerController field_6327_b;
	private boolean a = false;
	public int displayWidth;
	public int displayHeight;
	private OpenGlCapsChecker glCapabilities;
	private Timer timer = new Timer(20.0F);
	public World theWorld;
	public RenderGlobal field_6323_f;
	public EntityPlayerSP thePlayer;
	public EffectRenderer field_6321_h;
	public Session field_6320_i = null;
	public String field_6319_j;
	public Canvas mcCanvas;
	public boolean field_6317_l = true;
	public volatile boolean field_6316_m = false;
	public RenderEngine renderEngine;
	public FontRenderer fontRenderer;
	public GuiScreen currentScreen = null;
	public LoadingScreenRenderer loadingScreen = new LoadingScreenRenderer(this);
	public EntityRenderer field_9243_r = new EntityRenderer(this);
	private ThreadDownloadResources downloadResourcesThread;
	private int ticksRan = 0;
	private int field_6282_S = 0;
	private int field_9236_T;
	private int field_9235_U;
	public String field_6310_s = null;
	public int field_6309_t = 0;
	public GuiIngame ingameGUI;
	public boolean field_6307_v = false;
	public ModelBiped field_9242_w = new ModelBiped(0.0F);
	public MovingObjectPosition objectMouseOver = null;
	public GameSettings gameSettings;
	protected MinecraftApplet mcApplet;
	public SoundManager sndManager = new SoundManager();
	public MouseHelper mouseHelper;
	public TexturePackList texturePackList;
	public File field_6297_D;
	public static long[] field_9240_E = new long[512];
	public static long[] field_9239_F = new long[512];
	public static int field_9238_G = 0;
	private String field_9234_V;
	private int field_9233_W;
	private TextureWaterFX field_9232_X = new TextureWaterFX();
	private TextureLavaFX field_9231_Y = new TextureLavaFX();
	private static File minecraftDir = null;
	public volatile boolean running = true;
	public String field_6292_I = "";
	boolean field_6291_J = false;
	long field_6290_K = -1L;
	public boolean field_6289_L = false;
	private int field_6302_aa = 0;
	public boolean field_6288_M = false;
	long field_6287_N = System.currentTimeMillis();
	private int field_6300_ab = 0;

	public Minecraft(Component component1, Canvas canvas2, MinecraftApplet minecraftApplet3, int i4, int i5, boolean z6) {
		this.field_9236_T = i4;
		this.field_9235_U = i5;
		this.a = z6;
		this.mcApplet = minecraftApplet3;
		new ThreadSleepForever(this, "Timer hack thread");
		this.mcCanvas = canvas2;
		this.displayWidth = i4;
		this.displayHeight = i5;
		this.a = z6;
	}

	public abstract void func_4007_a(UnexpectedThrowable unexpectedThrowable1);

	public void func_6258_a(String string1, int i2) {
		this.field_9234_V = string1;
		this.field_9233_W = i2;
	}

	public void startGame() throws LWJGLException {
		if(this.mcCanvas != null) {
			Graphics graphics1 = this.mcCanvas.getGraphics();
			if(graphics1 != null) {
				graphics1.setColor(Color.BLACK);
				graphics1.fillRect(0, 0, this.displayWidth, this.displayHeight);
				graphics1.dispose();
			}

			Display.setParent(this.mcCanvas);
		} else if(this.a) {
			Display.setFullscreen(true);
			this.displayWidth = Display.getDisplayMode().getWidth();
			this.displayHeight = Display.getDisplayMode().getHeight();
			if(this.displayWidth <= 0) {
				this.displayWidth = 1;
			}

			if(this.displayHeight <= 0) {
				this.displayHeight = 1;
			}
		} else {
			Display.setDisplayMode(new DisplayMode(this.displayWidth, this.displayHeight));
		}

		Display.setTitle("Minecraft Minecraft Alpha v1.2.6");

		try {
			Display.create();
		} catch (LWJGLException lWJGLException6) {
			lWJGLException6.printStackTrace();

			try {
				Thread.sleep(1000L);
			} catch (InterruptedException interruptedException5) {
			}

			Display.create();
		}

		RenderManager.instance.field_4236_f = new ItemRenderer(this);
		this.field_6297_D = getMinecraftDir();
		this.gameSettings = new GameSettings(this, this.field_6297_D);
		this.texturePackList = new TexturePackList(this, this.field_6297_D);
		this.renderEngine = new RenderEngine(this.texturePackList, this.gameSettings);
		this.fontRenderer = new FontRenderer(this.gameSettings, "/font/default.png", this.renderEngine);
		this.loadScreen();
		Keyboard.create();
		Mouse.create();
		this.mouseHelper = new MouseHelper(this.mcCanvas);

		try {
			Controllers.create();
		} catch (Exception exception4) {
			exception4.printStackTrace();
		}

		this.checkGLError("Pre startup");
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		GL11.glShadeModel(GL11.GL_SMOOTH);
		GL11.glClearDepth(1.0D);
		GL11.glEnable(GL11.GL_DEPTH_TEST);
		GL11.glDepthFunc(GL11.GL_LEQUAL);
		GL11.glEnable(GL11.GL_ALPHA_TEST);
		GL11.glAlphaFunc(GL11.GL_GREATER, 0.1F);
		GL11.glCullFace(GL11.GL_BACK);
		GL11.glMatrixMode(GL11.GL_PROJECTION);
		GL11.glLoadIdentity();
		GL11.glMatrixMode(GL11.GL_MODELVIEW);
		this.checkGLError("Startup");
		this.glCapabilities = new OpenGlCapsChecker();
		this.sndManager.func_340_a(this.gameSettings);
		this.renderEngine.registerTextureFX(this.field_9231_Y);
		this.renderEngine.registerTextureFX(this.field_9232_X);
		this.renderEngine.registerTextureFX(new TexturePortalFX());
		this.renderEngine.registerTextureFX(new TextureCompassFX(this));
		this.renderEngine.registerTextureFX(new TextureWatchFX(this));
		this.renderEngine.registerTextureFX(new TexureWaterFlowFX());
		this.renderEngine.registerTextureFX(new TextureLavaFlowFX());
		this.renderEngine.registerTextureFX(new TextureFlamesFX(0));
		this.renderEngine.registerTextureFX(new TextureFlamesFX(1));
		this.field_6323_f = new RenderGlobal(this, this.renderEngine);
		GL11.glViewport(0, 0, this.displayWidth, this.displayHeight);
		this.field_6321_h = new EffectRenderer(this.theWorld, this.renderEngine);

		try {
			this.downloadResourcesThread = new ThreadDownloadResources(this.field_6297_D, this);
			this.downloadResourcesThread.start();
		} catch (Exception exception3) {
		}

		this.checkGLError("Post startup");
		this.ingameGUI = new GuiIngame(this);
		if(this.field_9234_V != null) {
			this.displayGuiScreen(new GuiConnecting(this, this.field_9234_V, this.field_9233_W));
		} else {
			this.displayGuiScreen(new GuiMainMenu());
		}

	}

	private void loadScreen() throws LWJGLException {
		ScaledResolution scaledResolution1 = new ScaledResolution(this.displayWidth, this.displayHeight);
		int i2 = scaledResolution1.getScaledWidth();
		int i3 = scaledResolution1.getScaledHeight();
		GL11.glClear(GL11.GL_COLOR_BUFFER_BIT | GL11.GL_DEPTH_BUFFER_BIT);
		GL11.glMatrixMode(GL11.GL_PROJECTION);
		GL11.glLoadIdentity();
		GL11.glOrtho(0.0D, (double)i2, (double)i3, 0.0D, 1000.0D, 3000.0D);
		GL11.glMatrixMode(GL11.GL_MODELVIEW);
		GL11.glLoadIdentity();
		GL11.glTranslatef(0.0F, 0.0F, -2000.0F);
		GL11.glViewport(0, 0, this.displayWidth, this.displayHeight);
		GL11.glClearColor(0.0F, 0.0F, 0.0F, 0.0F);
		Tessellator tessellator4 = Tessellator.instance;
		GL11.glDisable(GL11.GL_LIGHTING);
		GL11.glEnable(GL11.GL_TEXTURE_2D);
		GL11.glDisable(GL11.GL_FOG);
		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.renderEngine.getTexture("/title/mojang.png"));
		tessellator4.startDrawingQuads();
		tessellator4.setColorOpaque_I(0xFFFFFF);
		tessellator4.addVertexWithUV(0.0D, (double)this.displayHeight, 0.0D, 0.0D, 0.0D);
		tessellator4.addVertexWithUV((double)this.displayWidth, (double)this.displayHeight, 0.0D, 0.0D, 0.0D);
		tessellator4.addVertexWithUV((double)this.displayWidth, 0.0D, 0.0D, 0.0D, 0.0D);
		tessellator4.addVertexWithUV(0.0D, 0.0D, 0.0D, 0.0D, 0.0D);
		tessellator4.draw();
		short s5 = 256;
		short s6 = 256;
		GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
		tessellator4.setColorOpaque_I(0xFFFFFF);
		this.func_6274_a((this.displayWidth / 2 - s5) / 2, (this.displayHeight / 2 - s6) / 2, 0, 0, s5, s6);
		GL11.glDisable(GL11.GL_LIGHTING);
		GL11.glDisable(GL11.GL_FOG);
		GL11.glEnable(GL11.GL_ALPHA_TEST);
		GL11.glAlphaFunc(GL11.GL_GREATER, 0.1F);
		Display.swapBuffers();
	}

	public void func_6274_a(int i1, int i2, int i3, int i4, int i5, int i6) {
		float f7 = 0.00390625F;
		float f8 = 0.00390625F;
		Tessellator tessellator9 = Tessellator.instance;
		tessellator9.startDrawingQuads();
		tessellator9.addVertexWithUV((double)(i1 + 0), (double)(i2 + i6), 0.0D, (double)((float)(i3 + 0) * f7), (double)((float)(i4 + i6) * f8));
		tessellator9.addVertexWithUV((double)(i1 + i5), (double)(i2 + i6), 0.0D, (double)((float)(i3 + i5) * f7), (double)((float)(i4 + i6) * f8));
		tessellator9.addVertexWithUV((double)(i1 + i5), (double)(i2 + 0), 0.0D, (double)((float)(i3 + i5) * f7), (double)((float)(i4 + 0) * f8));
		tessellator9.addVertexWithUV((double)(i1 + 0), (double)(i2 + 0), 0.0D, (double)((float)(i3 + 0) * f7), (double)((float)(i4 + 0) * f8));
		tessellator9.draw();
	}

	public static File getMinecraftDir() {
		if(minecraftDir == null) {
			minecraftDir = getAppDir("minecraft");
		}

		return minecraftDir;
	}

	public static File getAppDir(String string0) {
		String string1 = System.getProperty("user.home", ".");
		File file2;
		switch(Minecraft.SyntheticClass_1.$SwitchMap$net$minecraft$src$EnumOS2[getOs().ordinal()]) {
		case 1:
		case 2:
			file2 = new File(string1, '.' + string0 + '/');
			break;
		case 3:
			String string3 = System.getenv("APPDATA");
			if(string3 != null) {
				file2 = new File(string3, "." + string0 + '/');
			} else {
				file2 = new File(string1, '.' + string0 + '/');
			}
			break;
		case 4:
			file2 = new File(string1, "Library/Application Support/" + string0);
			break;
		default:
			file2 = new File(string1, string0 + '/');
		}

		if(!file2.exists() && !file2.mkdirs()) {
			throw new RuntimeException("The working directory could not be created: " + file2);
		} else {
			return file2;
		}
	}

	private static EnumOS2 getOs() {
		String string0 = System.getProperty("os.name").toLowerCase();
		return string0.contains("win") ? EnumOS2.c : (string0.contains("mac") ? EnumOS2.d : (string0.contains("solaris") ? EnumOS2.b : (string0.contains("sunos") ? EnumOS2.b : (string0.contains("linux") ? EnumOS2.a : (string0.contains("unix") ? EnumOS2.a : EnumOS2.unknown)))));
	}

	public void displayGuiScreen(GuiScreen guiScreen1) {
		if(!(this.currentScreen instanceof GuiUnused)) {
			if(this.currentScreen != null) {
				this.currentScreen.onGuiClosed();
			}

			if(guiScreen1 == null && this.theWorld == null) {
				guiScreen1 = new GuiMainMenu();
			} else if(guiScreen1 == null && this.thePlayer.health <= 0) {
				guiScreen1 = new GuiGameOver();
			}

			this.currentScreen = (GuiScreen)guiScreen1;
			if(guiScreen1 != null) {
				this.func_6273_f();
				ScaledResolution scaledResolution2 = new ScaledResolution(this.displayWidth, this.displayHeight);
				int i3 = scaledResolution2.getScaledWidth();
				int i4 = scaledResolution2.getScaledHeight();
				((GuiScreen)guiScreen1).setWorldAndResolution(this, i3, i4);
				this.field_6307_v = false;
			} else {
				this.func_6259_e();
			}

		}
	}

	private void checkGLError(String string1) {
		int i2 = GL11.glGetError();
		if(i2 != 0) {
			String string3 = GLU.gluErrorString(i2);
			System.out.println("########## GL ERROR ##########");
			System.out.println("@ " + string1);
			System.out.println(i2 + ": " + string3);
			System.exit(0);
		}

	}

	public void func_6266_c() {
		if(this.mcApplet != null) {
			this.mcApplet.func_6231_c();
		}

		try {
			if(this.downloadResourcesThread != null) {
				this.downloadResourcesThread.closeMinecraft();
			}
		} catch (Exception exception8) {
		}

		try {
			System.out.println("Stopping!");
			this.func_6261_a((World)null);

			try {
				GLAllocation.deleteTexturesAndDisplayLists();
			} catch (Exception exception6) {
			}

			this.sndManager.closeMinecraft();
			Mouse.destroy();
			Keyboard.destroy();
		} finally {
			Display.destroy();
		}

		System.gc();
	}

	public void run() {
		this.running = true;

		try {
			this.startGame();
		} catch (Exception exception15) {
			exception15.printStackTrace();
			this.func_4007_a(new UnexpectedThrowable("Failed to start game", exception15));
			return;
		}

		try {
			try {
				long j1 = System.currentTimeMillis();
				int i3 = 0;

				while(this.running && (this.mcApplet == null || this.mcApplet.isActive())) {
					AxisAlignedBB.clearBoundingBoxPool();
					Vec3D.initialize();
					if(this.mcCanvas == null && Display.isCloseRequested()) {
						this.shutdown();
					}

					if(this.field_6316_m && this.theWorld != null) {
						float f4 = this.timer.renderPartialTicks;
						this.timer.updateTimer();
						this.timer.renderPartialTicks = f4;
					} else {
						this.timer.updateTimer();
					}

					long j19 = System.nanoTime();

					for(int i6 = 0; i6 < this.timer.elapsedTicks; ++i6) {
						++this.ticksRan;

						try {
							this.runTick();
						} catch (MinecraftException minecraftException14) {
							this.theWorld = null;
							this.func_6261_a((World)null);
							this.displayGuiScreen(new GuiConflictWarning());
						}
					}

					long j20 = System.nanoTime() - j19;
					this.checkGLError("Pre render");
					this.sndManager.func_338_a(this.thePlayer, this.timer.renderPartialTicks);
					GL11.glEnable(GL11.GL_TEXTURE_2D);
					if(this.theWorld != null && !this.theWorld.multiplayerWorld) {
						while(this.theWorld.func_6465_g()) {
						}
					}

					if(this.theWorld != null && this.theWorld.multiplayerWorld) {
						this.theWorld.func_6465_g();
					}

					if(this.gameSettings.limitFramerate) {
						Thread.sleep(5L);
					}

					if(!Keyboard.isKeyDown(Keyboard.KEY_F7)) {
						Display.update();
					}

					if(!this.field_6307_v) {
						if(this.field_6327_b != null) {
							this.field_6327_b.func_6467_a(this.timer.renderPartialTicks);
						}

						this.field_9243_r.func_4136_b(this.timer.renderPartialTicks);
					}

					if(!Display.isActive()) {
						if(this.a) {
							this.toggleFullscreen();
						}

						Thread.sleep(10L);
					}

					if(Keyboard.isKeyDown(Keyboard.KEY_F3)) {
						this.func_6238_a(j20);
					} else {
						this.field_6290_K = System.nanoTime();
					}

					Thread.yield();
					if(Keyboard.isKeyDown(Keyboard.KEY_F7)) {
						Display.update();
					}

					this.func_6248_s();
					if(this.mcCanvas != null && !this.a && (this.mcCanvas.getWidth() != this.displayWidth || this.mcCanvas.getHeight() != this.displayHeight)) {
						this.displayWidth = this.mcCanvas.getWidth();
						this.displayHeight = this.mcCanvas.getHeight();
						if(this.displayWidth <= 0) {
							this.displayWidth = 1;
						}

						if(this.displayHeight <= 0) {
							this.displayHeight = 1;
						}

						this.resize(this.displayWidth, this.displayHeight);
					}

					this.checkGLError("Post render");
					++i3;

					for(this.field_6316_m = !this.isMultiplayerWorld() && this.currentScreen != null && this.currentScreen.doesGuiPauseGame(); System.currentTimeMillis() >= j1 + 1000L; i3 = 0) {
						this.field_6292_I = i3 + " fps, " + WorldRenderer.field_1762_b + " chunk updates";
						WorldRenderer.field_1762_b = 0;
						j1 += 1000L;
					}
				}
			} catch (MinecraftError minecraftError16) {
			} catch (Throwable throwable17) {
				this.theWorld = null;
				throwable17.printStackTrace();
				this.func_4007_a(new UnexpectedThrowable("Unexpected error", throwable17));
			}

		} finally {
		}
	}

	private void func_6248_s() {
		if(Keyboard.isKeyDown(Keyboard.KEY_F2)) {
			if(!this.field_6291_J) {

					this.ingameGUI.addChatMessage(ScreenShotHelper.func_4148_a(minecraftDir, this.displayWidth, this.displayHeight));


				this.field_6291_J = true;
			}
		} else {
			this.field_6291_J = false;
		}

	}

	private void func_6238_a(long j1) {
		long j3 = 16666666L;
		if(this.field_6290_K == -1L) {
			this.field_6290_K = System.nanoTime();
		}

		long j5 = System.nanoTime();
		field_9239_F[field_9238_G & field_9240_E.length - 1] = j1;
		field_9240_E[field_9238_G++ & field_9240_E.length - 1] = j5 - this.field_6290_K;
		this.field_6290_K = j5;
		GL11.glClear(GL11.GL_DEPTH_BUFFER_BIT);
		GL11.glMatrixMode(GL11.GL_PROJECTION);
		GL11.glLoadIdentity();
		GL11.glOrtho(0.0D, (double)this.displayWidth, (double)this.displayHeight, 0.0D, 1000.0D, 3000.0D);
		GL11.glMatrixMode(GL11.GL_MODELVIEW);
		GL11.glLoadIdentity();
		GL11.glTranslatef(0.0F, 0.0F, -2000.0F);
		GL11.glLineWidth(1.0F);
		GL11.glDisable(GL11.GL_TEXTURE_2D);
		Tessellator tessellator7 = Tessellator.instance;
		tessellator7.startDrawing(7);
		int i8 = (int)(j3 / 200000L);
		tessellator7.setColorOpaque_I(536870912);
		tessellator7.addVertex(0.0D, (double)(this.displayHeight - i8), 0.0D);
		tessellator7.addVertex(0.0D, (double)this.displayHeight, 0.0D);
		tessellator7.addVertex((double)field_9240_E.length, (double)this.displayHeight, 0.0D);
		tessellator7.addVertex((double)field_9240_E.length, (double)(this.displayHeight - i8), 0.0D);
		tessellator7.setColorOpaque_I(0x20200000);
		tessellator7.addVertex(0.0D, (double)(this.displayHeight - i8 * 2), 0.0D);
		tessellator7.addVertex(0.0D, (double)(this.displayHeight - i8), 0.0D);
		tessellator7.addVertex((double)field_9240_E.length, (double)(this.displayHeight - i8), 0.0D);
		tessellator7.addVertex((double)field_9240_E.length, (double)(this.displayHeight - i8 * 2), 0.0D);
		tessellator7.draw();
		long j9 = 0L;

		int i11;
		for(i11 = 0; i11 < field_9240_E.length; ++i11) {
			j9 += field_9240_E[i11];
		}

		i11 = (int)(j9 / 200000L / (long)field_9240_E.length);
		tessellator7.startDrawing(7);
		tessellator7.setColorOpaque_I(0x20400000);
		tessellator7.addVertex(0.0D, (double)(this.displayHeight - i11), 0.0D);
		tessellator7.addVertex(0.0D, (double)this.displayHeight, 0.0D);
		tessellator7.addVertex((double)field_9240_E.length, (double)this.displayHeight, 0.0D);
		tessellator7.addVertex((double)field_9240_E.length, (double)(this.displayHeight - i11), 0.0D);
		tessellator7.draw();
		tessellator7.startDrawing(1);

		for(int i12 = 0; i12 < field_9240_E.length; ++i12) {
			int i13 = (i12 - field_9238_G & field_9240_E.length - 1) * 255 / field_9240_E.length;
			int i14 = i13 * i13 / 255;
			i14 = i14 * i14 / 255;
			int i15 = i14 * i14 / 255;
			i15 = i15 * i15 / 255;
			if(field_9240_E[i12] > j3) {
				tessellator7.setColorOpaque_I(0xFF000000 + i14 * 65536);
			} else {
				tessellator7.setColorOpaque_I(0xFF000000 + i14 * 256);
			}

			long j16 = field_9240_E[i12] / 200000L;
			long j18 = field_9239_F[i12] / 200000L;
			tessellator7.addVertex((double)((float)i12 + 0.5F), (double)((float)((long)this.displayHeight - j16) + 0.5F), 0.0D);
			tessellator7.addVertex((double)((float)i12 + 0.5F), (double)((float)this.displayHeight + 0.5F), 0.0D);
			tessellator7.setColorOpaque_I(0xFF000000 + i14 * 65536 + i14 * 256 + i14 * 1);
			tessellator7.addVertex((double)((float)i12 + 0.5F), (double)((float)((long)this.displayHeight - j16) + 0.5F), 0.0D);
			tessellator7.addVertex((double)((float)i12 + 0.5F), (double)((float)((long)this.displayHeight - (j16 - j18)) + 0.5F), 0.0D);
		}

		tessellator7.draw();
		GL11.glEnable(GL11.GL_TEXTURE_2D);
	}

	public void shutdown() {
		this.running = false;
	}

	public void func_6259_e() {
		if(Display.isActive()) {
			if(!this.field_6289_L) {
				this.field_6289_L = true;
				this.mouseHelper.func_774_a();
				this.displayGuiScreen((GuiScreen)null);
				this.field_6302_aa = this.ticksRan + 10000;
			}
		}
	}

	public void func_6273_f() {
		if(this.field_6289_L) {
			if(this.thePlayer != null) {
				this.thePlayer.func_458_k();
			}

			this.field_6289_L = false;
			this.mouseHelper.func_773_b();
		}
	}

	public void func_6252_g() {
		if(this.currentScreen == null) {
			this.displayGuiScreen(new GuiIngameMenu());
		}
	}

	private void func_6254_a(int i1, boolean z2) {
		if(!this.field_6327_b.field_1064_b) {
			if(i1 != 0 || this.field_6282_S <= 0) {
				if(z2 && this.objectMouseOver != null && this.objectMouseOver.typeOfHit == 0 && i1 == 0) {
					int i3 = this.objectMouseOver.blockX;
					int i4 = this.objectMouseOver.blockY;
					int i5 = this.objectMouseOver.blockZ;
					this.field_6327_b.sendBlockRemoving(i3, i4, i5, this.objectMouseOver.sideHit);
					this.field_6321_h.func_1191_a(i3, i4, i5, this.objectMouseOver.sideHit);
				} else {
					this.field_6327_b.func_6468_a();
				}

			}
		}
	}

	private void clickMouse(int i1) {
		if(i1 != 0 || this.field_6282_S <= 0) {
			if(i1 == 0) {
				this.thePlayer.func_457_w();
			}

			boolean z2 = true;
			if(this.objectMouseOver == null) {
				if(i1 == 0 && !(this.field_6327_b instanceof PlayerControllerTest)) {
					this.field_6282_S = 10;
				}
			} else if(this.objectMouseOver.typeOfHit == 1) {
				if(i1 == 0) {
					this.field_6327_b.func_6472_b(this.thePlayer, this.objectMouseOver.entityHit);
				}

				if(i1 == 1) {
					this.field_6327_b.func_6475_a(this.thePlayer, this.objectMouseOver.entityHit);
				}
			} else if(this.objectMouseOver.typeOfHit == 0) {
				int i3 = this.objectMouseOver.blockX;
				int i4 = this.objectMouseOver.blockY;
				int i5 = this.objectMouseOver.blockZ;
				int i6 = this.objectMouseOver.sideHit;
				Block block7 = Block.blocksList[this.theWorld.getBlockId(i3, i4, i5)];
				if(i1 == 0) {
					this.theWorld.onBlockHit(i3, i4, i5, this.objectMouseOver.sideHit);
					if(block7 != Block.bedrock || this.thePlayer.field_9371_f >= 100) {
						this.field_6327_b.clickBlock(i3, i4, i5, this.objectMouseOver.sideHit);
					}
				} else {
					ItemStack itemStack8 = this.thePlayer.inventory.getCurrentItem();
					int i9 = itemStack8 != null ? itemStack8.stackSize : 0;
					if(this.field_6327_b.sendPlaceBlock(this.thePlayer, this.theWorld, itemStack8, i3, i4, i5, i6)) {
						z2 = false;
						this.thePlayer.func_457_w();
					}

					if(itemStack8 == null) {
						return;
					}

					if(itemStack8.stackSize == 0) {
						this.thePlayer.inventory.mainInventory[this.thePlayer.inventory.currentItem] = null;
					} else if(itemStack8.stackSize != i9) {
						this.field_9243_r.field_1395_a.func_9449_b();
					}
				}
			}

			if(z2 && i1 == 1) {
				ItemStack itemStack10 = this.thePlayer.inventory.getCurrentItem();
				if(itemStack10 != null && this.field_6327_b.sendUseItem(this.thePlayer, this.theWorld, itemStack10)) {
					this.field_9243_r.field_1395_a.func_9450_c();
				}
			}

		}
	}

	public void toggleFullscreen() {
		try {
			this.a = !this.a;
			System.out.println("Toggle fullscreen!");
			if(this.a) {
				Display.setDisplayMode(Display.getDesktopDisplayMode());
				this.displayWidth = Display.getDisplayMode().getWidth();
				this.displayHeight = Display.getDisplayMode().getHeight();
				if(this.displayWidth <= 0) {
					this.displayWidth = 1;
				}

				if(this.displayHeight <= 0) {
					this.displayHeight = 1;
				}
			} else {
				if(this.mcCanvas != null) {
					this.displayWidth = this.mcCanvas.getWidth();
					this.displayHeight = this.mcCanvas.getHeight();
				} else {
					this.displayWidth = this.field_9236_T;
					this.displayHeight = this.field_9235_U;
				}

				if(this.displayWidth <= 0) {
					this.displayWidth = 1;
				}

				if(this.displayHeight <= 0) {
					this.displayHeight = 1;
				}

				Display.setDisplayMode(new DisplayMode(this.field_9236_T, this.field_9235_U));
			}

			this.func_6273_f();
			Display.setFullscreen(this.a);
			Display.update();
			Thread.sleep(1000L);
			if(this.a) {
				this.func_6259_e();
			}

			if(this.currentScreen != null) {
				this.func_6273_f();
				this.resize(this.displayWidth, this.displayHeight);
			}

			System.out.println("Size: " + this.displayWidth + ", " + this.displayHeight);
		} catch (Exception exception2) {
			exception2.printStackTrace();
		}

	}

	private void resize(int i1, int i2) {
		if(i1 <= 0) {
			i1 = 1;
		}

		if(i2 <= 0) {
			i2 = 1;
		}

		this.displayWidth = i1;
		this.displayHeight = i2;
		if(this.currentScreen != null) {
			ScaledResolution scaledResolution3 = new ScaledResolution(i1, i2);
			int i4 = scaledResolution3.getScaledWidth();
			int i5 = scaledResolution3.getScaledHeight();
			this.currentScreen.setWorldAndResolution(this, i4, i5);
		}

	}

	private void clickMiddleMouseButton() {
		if(this.objectMouseOver != null) {
			int i1 = this.theWorld.getBlockId(this.objectMouseOver.blockX, this.objectMouseOver.blockY, this.objectMouseOver.blockZ);
			if(i1 == Block.grass.blockID) {
				i1 = Block.dirt.blockID;
			}

			if(i1 == Block.stairDouble.blockID) {
				i1 = Block.stairSingle.blockID;
			}

			if(i1 == Block.bedrock.blockID) {
				i1 = Block.stone.blockID;
			}

			this.thePlayer.inventory.setCurrentItem(i1, this.field_6327_b instanceof PlayerControllerTest);
		}

	}

	public void runTick() {
		this.ingameGUI.func_555_a();
		this.field_9243_r.func_910_a(1.0F);
		if(this.thePlayer != null) {
			this.thePlayer.func_6420_o();
		}

		if(!this.field_6316_m && this.theWorld != null) {
			this.field_6327_b.func_6474_c();
		}

		GL11.glBindTexture(GL11.GL_TEXTURE_2D, this.renderEngine.getTexture("/terrain.png"));
		if(!this.field_6316_m) {
			this.renderEngine.func_1067_a();
		}

		if(this.currentScreen == null && this.thePlayer != null && this.thePlayer.health <= 0) {
			this.displayGuiScreen((GuiScreen)null);
		}

		if(this.currentScreen != null) {
			this.field_6302_aa = this.ticksRan + 10000;
		}

		if(this.currentScreen != null) {
			this.currentScreen.handleInput();
			if(this.currentScreen != null) {
				this.currentScreen.updateScreen();
			}
		}

		if(this.currentScreen == null || this.currentScreen.field_948_f) {
			label238:
			while(true) {
				while(true) {
					while(true) {
						long j1;
						do {
							if(!Mouse.next()) {
								if(this.field_6282_S > 0) {
									--this.field_6282_S;
								}

								while(true) {
									while(true) {
										do {
											if(!Keyboard.next()) {
												if(this.currentScreen == null) {
													if(Mouse.isButtonDown(0) && (float)(this.ticksRan - this.field_6302_aa) >= this.timer.ticksPerSecond / 4.0F && this.field_6289_L) {
														this.clickMouse(0);
														this.field_6302_aa = this.ticksRan;
													}

													if(Mouse.isButtonDown(1) && (float)(this.ticksRan - this.field_6302_aa) >= this.timer.ticksPerSecond / 4.0F && this.field_6289_L) {
														this.clickMouse(1);
														this.field_6302_aa = this.ticksRan;
													}
												}

												this.func_6254_a(0, this.currentScreen == null && Mouse.isButtonDown(0) && this.field_6289_L);
												break label238;
											}

											this.thePlayer.func_460_a(Keyboard.getEventKey(), Keyboard.getEventKeyState());
										} while(!Keyboard.getEventKeyState());

										if(Keyboard.getEventKey() == Keyboard.KEY_F11) {
											this.toggleFullscreen();
										} else {
											if(this.currentScreen != null) {
												this.currentScreen.handleKeyboardInput();
											} else {
												if(Keyboard.getEventKey() == Keyboard.KEY_ESCAPE) {
													this.func_6252_g();
												}

												if(Keyboard.getEventKey() == Keyboard.KEY_S && Keyboard.isKeyDown(Keyboard.KEY_F3)) {
													this.forceReload();
												}

												if(Keyboard.getEventKey() == Keyboard.KEY_F5) {
													this.gameSettings.thirdPersonView = !this.gameSettings.thirdPersonView;
												}

												if(Keyboard.getEventKey() == this.gameSettings.keyBindInventory.keyCode) {
													this.displayGuiScreen(new GuiInventory(this.thePlayer.inventory, this.thePlayer.inventory.craftingInventory));
												}

												if(Keyboard.getEventKey() == this.gameSettings.keyBindDrop.keyCode) {
													this.thePlayer.dropPlayerItemWithRandomChoice(this.thePlayer.inventory.decrStackSize(this.thePlayer.inventory.currentItem, 1), false);
												}

												if(this.isMultiplayerWorld() && Keyboard.getEventKey() == this.gameSettings.keyBindChat.keyCode) {
													this.displayGuiScreen(new GuiChat());
												}
											}

											for(int i4 = 0; i4 < 9; ++i4) {
												if(Keyboard.getEventKey() == Keyboard.KEY_1 + i4) {
													this.thePlayer.inventory.currentItem = i4;
												}
											}

											if(Keyboard.getEventKey() == this.gameSettings.keyBindToggleFog.keyCode) {
												this.gameSettings.setOptionValue(4, !Keyboard.isKeyDown(Keyboard.KEY_LSHIFT) && !Keyboard.isKeyDown(Keyboard.KEY_RSHIFT) ? 1 : -1);
											}
										}
									}
								}
							}

							j1 = System.currentTimeMillis() - this.field_6287_N;
						} while(j1 > 200L);

						int i3 = Mouse.getEventDWheel();
						if(i3 != 0) {
							this.thePlayer.inventory.changeCurrentItem(i3);
						}

						if(this.currentScreen == null) {
							if(!this.field_6289_L && Mouse.getEventButtonState()) {
								this.func_6259_e();
							} else {
								if(Mouse.getEventButton() == 0 && Mouse.getEventButtonState()) {
									this.clickMouse(0);
									this.field_6302_aa = this.ticksRan;
								}

								if(Mouse.getEventButton() == 1 && Mouse.getEventButtonState()) {
									this.clickMouse(1);
									this.field_6302_aa = this.ticksRan;
								}

								if(Mouse.getEventButton() == 2 && Mouse.getEventButtonState()) {
									this.clickMiddleMouseButton();
								}
							}
						} else if(this.currentScreen != null) {
							this.currentScreen.handleMouseInput();
						}
					}
				}
			}
		}

		if(this.theWorld != null) {
			if(this.thePlayer != null) {
				++this.field_6300_ab;
				if(this.field_6300_ab == 30) {
					this.field_6300_ab = 0;
					this.theWorld.func_705_f(this.thePlayer);
				}
			}

			this.theWorld.difficultySetting = this.gameSettings.difficulty;
			if(this.theWorld.multiplayerWorld) {
				this.theWorld.difficultySetting = 3;
			}

			if(!this.field_6316_m) {
				this.field_9243_r.func_911_a();
			}

			if(!this.field_6316_m) {
				this.field_6323_f.func_945_d();
			}

			if(!this.field_6316_m) {
				this.theWorld.func_633_c();
			}

			if(!this.field_6316_m || this.isMultiplayerWorld()) {
				this.theWorld.tick();
			}

			if(!this.field_6316_m && this.theWorld != null) {
				this.theWorld.randomDisplayUpdates(MathHelper.floor_double(this.thePlayer.posX), MathHelper.floor_double(this.thePlayer.posY), MathHelper.floor_double(this.thePlayer.posZ));
			}

			if(!this.field_6316_m) {
				this.field_6321_h.func_1193_a();
			}
		}

		this.field_6287_N = System.currentTimeMillis();
	}

	private void forceReload() {
		System.out.println("FORCING RELOAD!");
		this.sndManager = new SoundManager();
		this.sndManager.func_340_a(this.gameSettings);
		this.downloadResourcesThread.reloadResources();
	}

	public boolean isMultiplayerWorld() {
		return this.theWorld != null && this.theWorld.multiplayerWorld;
	}

	public void func_6247_b(String string1) {
		this.func_6261_a((World)null);
		System.gc();
		World world2 = new World(new File(getMinecraftDir(), "saves"), string1);
		if(world2.field_1033_r) {
			this.func_6263_a(world2, "Generating level");
		} else {
			this.func_6263_a(world2, "Loading level");
		}

	}

	public void func_6237_k() {
		if(this.thePlayer.dimension == -1) {
			this.thePlayer.dimension = 0;
		} else {
			this.thePlayer.dimension = -1;
		}

		this.theWorld.setEntityDead(this.thePlayer);
		this.thePlayer.isDead = false;
		double d1 = this.thePlayer.posX;
		double d3 = this.thePlayer.posZ;
		double d5 = 8.0D;
		World world7;
		if(this.thePlayer.dimension == -1) {
			d1 /= d5;
			d3 /= d5;
			this.thePlayer.setLocationAndAngles(d1, this.thePlayer.posY, d3, this.thePlayer.rotationYaw, this.thePlayer.rotationPitch);
			this.theWorld.func_4084_a(this.thePlayer, false);
			world7 = new World(this.theWorld, new WorldProviderHell());
			this.func_6256_a(world7, "Entering the Nether", this.thePlayer);
		} else {
			d1 *= d5;
			d3 *= d5;
			this.thePlayer.setLocationAndAngles(d1, this.thePlayer.posY, d3, this.thePlayer.rotationYaw, this.thePlayer.rotationPitch);
			this.theWorld.func_4084_a(this.thePlayer, false);
			world7 = new World(this.theWorld, new WorldProvider());
			this.func_6256_a(world7, "Leaving the Nether", this.thePlayer);
		}

		this.thePlayer.worldObj = this.theWorld;
		this.thePlayer.setLocationAndAngles(d1, this.thePlayer.posY, d3, this.thePlayer.rotationYaw, this.thePlayer.rotationPitch);
		this.theWorld.func_4084_a(this.thePlayer, false);
		(new Teleporter()).func_4107_a(this.theWorld, this.thePlayer);
	}

	public void func_6261_a(World world1) {
		this.func_6263_a(world1, "");
	}

	public void func_6263_a(World world1, String string2) {
		this.func_6256_a(world1, string2, (EntityPlayer)null);
	}

	public void func_6256_a(World world1, String string2, EntityPlayer entityPlayer3) {
		this.loadingScreen.func_596_a(string2);
		this.loadingScreen.displayLoadingString("");
		this.sndManager.func_331_a((String)null, 0.0F, 0.0F, 0.0F, 0.0F, 0.0F);
		if(this.theWorld != null) {
			this.theWorld.func_651_a(this.loadingScreen);
		}

		this.theWorld = world1;
		System.out.println("Player is " + this.thePlayer);
		if(world1 != null) {
			this.field_6327_b.func_717_a(world1);
			if(!this.isMultiplayerWorld()) {
				if(entityPlayer3 == null) {
					this.thePlayer = (EntityPlayerSP)world1.func_4085_a(EntityPlayerSP.class);
				}
			} else if(this.thePlayer != null) {
				this.thePlayer.preparePlayerToSpawn();
				if(world1 != null) {
					world1.entityJoinedWorld(this.thePlayer);
				}
			}

			if(!world1.multiplayerWorld) {
				this.func_6255_d(string2);
			}

			System.out.println("Player is now " + this.thePlayer);
			if(this.thePlayer == null) {
				this.thePlayer = (EntityPlayerSP)this.field_6327_b.func_4087_b(world1);
				this.thePlayer.preparePlayerToSpawn();
				this.field_6327_b.flipPlayer(this.thePlayer);
			}

			this.thePlayer.field_787_a = new MovementInputFromOptions(this.gameSettings);
			if(this.field_6323_f != null) {
				this.field_6323_f.func_946_a(world1);
			}

			if(this.field_6321_h != null) {
				this.field_6321_h.func_1188_a(world1);
			}

			this.field_6327_b.func_6473_b(this.thePlayer);
			if(entityPlayer3 != null) {
				world1.func_6464_c();
			}

			world1.func_608_a(this.thePlayer);
			if(world1.field_1033_r) {
				world1.func_651_a(this.loadingScreen);
			}
		} else {
			this.thePlayer = null;
		}

		System.gc();
		this.field_6287_N = 0L;
	}

	private void func_6255_d(String string1) {
		this.loadingScreen.func_596_a(string1);
		this.loadingScreen.displayLoadingString("Building terrain");
		short s2 = 128;
		int i3 = 0;
		int i4 = s2 * 2 / 16 + 1;
		i4 *= i4;

		for(int i5 = -s2; i5 <= s2; i5 += 16) {
			int i6 = this.theWorld.spawnX;
			int i7 = this.theWorld.spawnZ;
			if(this.thePlayer != null) {
				i6 = (int)this.thePlayer.posX;
				i7 = (int)this.thePlayer.posZ;
			}

			for(int i8 = -s2; i8 <= s2; i8 += 16) {
				this.loadingScreen.setLoadingProgress(i3++ * 100 / i4);
				this.theWorld.getBlockId(i6 + i5, 64, i7 + i8);

				while(this.theWorld.func_6465_g()) {
				}
			}
		}

		this.loadingScreen.displayLoadingString("Simulating world for a bit");
		boolean z9 = true;
		this.theWorld.func_656_j();
	}

	public void installResource(String string1, File file2) {
		int i3 = string1.indexOf("/");
		String string4 = string1.substring(0, i3);
		string1 = string1.substring(i3 + 1);
		if(string4.equalsIgnoreCase("sound")) {
			this.sndManager.func_6372_a(string1, file2);
		} else if(string4.equalsIgnoreCase("newsound")) {
			this.sndManager.func_6372_a(string1, file2);
		} else if(string4.equalsIgnoreCase("streaming")) {
			this.sndManager.addStreaming(string1, file2);
		} else if(string4.equalsIgnoreCase("music")) {
			this.sndManager.addMusic(string1, file2);
		} else if(string4.equalsIgnoreCase("newmusic")) {
			this.sndManager.addMusic(string1, file2);
		}

	}

	public OpenGlCapsChecker func_6251_l() {
		return this.glCapabilities;
	}

	public String func_6241_m() {
		return this.field_6323_f.func_953_b();
	}

	public String func_6262_n() {
		return this.field_6323_f.func_957_c();
	}

	public String func_6245_o() {
		return "P: " + this.field_6321_h.func_1190_b() + ". T: " + this.theWorld.func_687_d();
	}

	public void respawn() {
		if(!this.theWorld.worldProvider.func_6477_d()) {
			this.func_6237_k();
		}

		this.theWorld.func_4076_b();
		this.theWorld.func_9424_o();
		int i1 = 0;
		if(this.thePlayer != null) {
			i1 = this.thePlayer.field_620_ab;
			this.theWorld.setEntityDead(this.thePlayer);
		}

		this.thePlayer = (EntityPlayerSP)this.field_6327_b.func_4087_b(this.theWorld);
		this.thePlayer.preparePlayerToSpawn();
		this.field_6327_b.flipPlayer(this.thePlayer);
		this.theWorld.func_608_a(this.thePlayer);
		this.thePlayer.field_787_a = new MovementInputFromOptions(this.gameSettings);
		this.thePlayer.field_620_ab = i1;
		this.field_6327_b.func_6473_b(this.thePlayer);
		this.func_6255_d("Respawning");
		if(this.currentScreen instanceof GuiGameOver) {
			this.displayGuiScreen((GuiScreen)null);
		}

	}

	public static void func_6269_a(String string0, String string1) {
		func_6253_a(string0, string1, (String)null);
	}

	public static void func_6253_a(String string0, String string1, String string2) {
		boolean z3 = false;
		Frame frame5 = new Frame("Minecraft");
		Canvas canvas6 = new Canvas();
		frame5.setLayout(new BorderLayout());
		frame5.add(canvas6, "Center");
		canvas6.setPreferredSize(new Dimension(854, 480));
		frame5.pack();
		frame5.setLocationRelativeTo((Component)null);
		MinecraftImpl minecraftImpl7 = new MinecraftImpl(frame5, canvas6, (MinecraftApplet)null, 854, 480, z3, frame5);
		Thread thread8 = new Thread(minecraftImpl7, "Minecraft main thread");
		thread8.setPriority(10);
		minecraftImpl7.field_6317_l = false;
		minecraftImpl7.field_6319_j = "www.minecraft.net";
		if(string0 != null && string1 != null) {
			minecraftImpl7.field_6320_i = new Session(string0, string1);
		} else {
			minecraftImpl7.field_6320_i = new Session("Player" + System.currentTimeMillis() % 1000L, "");
		}

		if(string2 != null) {
			String[] string9 = string2.split(":");
			minecraftImpl7.func_6258_a(string9[0], Integer.parseInt(string9[1]));
		}

		frame5.setVisible(true);
		frame5.addWindowListener(new GameWindowListener(minecraftImpl7, thread8));
		thread8.start();
	}

	public static void main(String[] string0) {
		String string1 = "Player" + System.currentTimeMillis() % 1000L;
		if(string0.length > 0) {
			string1 = string0[0];
		}

		String string2 = "-";
		if(string0.length > 1) {
			string2 = string0[1];
		}

		string1 = "Player" + System.currentTimeMillis() % 1000L;
		string1 = "Player524";
		func_6269_a(string1, string2);
	}

	static final class SyntheticClass_1 {
		public static final int[] $SwitchMap$net$minecraft$src$EnumOS2 = new int[EnumOS2.values().length];

		static {
			try {
				$SwitchMap$net$minecraft$src$EnumOS2[EnumOS2.a.ordinal()] = 1;
			} catch (NoSuchFieldError noSuchFieldError4) {
			}

			try {
				$SwitchMap$net$minecraft$src$EnumOS2[EnumOS2.b.ordinal()] = 2;
			} catch (NoSuchFieldError noSuchFieldError3) {
			}

			try {
				$SwitchMap$net$minecraft$src$EnumOS2[EnumOS2.c.ordinal()] = 3;
			} catch (NoSuchFieldError noSuchFieldError2) {
			}

			try {
				$SwitchMap$net$minecraft$src$EnumOS2[EnumOS2.d.ordinal()] = 4;
			} catch (NoSuchFieldError noSuchFieldError1) {
			}

		}
	}
}
